<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'de',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fibers',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'Sprachreferenz',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'Exceptions erweitern',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'Generatoren',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'de',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fibers</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Übersicht über Fibers</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Fibers stellen unterbrechbare Funktionen dar, die den gesamten Aufrufstapel
   (Call-Stack) umfassen. Sie können an jeder Stelle des Aufrufstapels
   unterbrochen werden, wobei die Ausführung innerhalb der Fiber solange
   unterbrochen wird, bis die Fiber zu einem späteren Zeitpunkt fortgesetzt
   wird.
  </p>
  <p class="para">
   Fibers halten den gesamten Ausführungsstapel an, sodass der direkte
   Aufrufer der Funktion nicht ändern muss, wie er die Funktion aufruft.
  </p>
  <p class="para">
   Mit <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> kann die Ausführung an jeder
   Stelle im Aufrufstapel unterbrochen werden (d. h. der Aufruf von
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> kann in einer tief verschachtelten
   Funktion liegen oder auch gar nicht existieren).
  </p>
  <p class="para">
   Im Gegensatz zu einem <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>, der keinen Stapel
   hat, hat jede <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> ihren eigenen Aufrufstapel,
   sodass sie innerhalb tief verschachtelter Funktionsaufrufe unterbrochen
   werden kann. Im Gegensatz zu einer Funktion, die <a href="language.generators.syntax.php#control-structures.yield" class="link">yield</a> verwendet und eine
   <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>-Instanz zurückgeben muss, muss eine
   Funktion, die einen Unterbrechungspunkt deklariert (d. h.
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> aufruft), ihren Rückgabetyp nicht
   ändern.
  </p>
  <p class="para">
   Fibers können beim Aufruf einer beliebigen Funktion unterbrochen werden.
   Dies gilt auch für Funktionen, die innerhalb der PHP-VM aufgerufen werden,
   z. B. Funktionen, die an <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span> übergeben werden
   oder Methoden eines <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>-Objekts, die von
   <a href="control-structures.foreach.php" class="link">foreach</a> aufgerufen werden.
  </p>
  <p class="para">
   Sobald die Ausführung einer Fiber unterbrochen wurde, kann sie wieder
   aufgenommen werden, indem ein beliebiger Wert an
   <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span> übergeben wird oder indem
   <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span> verwendet wird, um eine Exception an
   die Fiber zu senden. Bei der Wiederaufnahme wird von
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> ein Wert zurückgegeben (oder es
   wird eine Exception ausgelöst).
  </p>
  <blockquote class="note"><p><strong class="note">Hinweis</strong>: 
   <span class="simpara">
    Aufgrund der derzeitigen Beschränkungen ist es nicht möglich, Fibers im
    Destruktor eines Objekts zu schalten.
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>Beispiel #1 Grundlegende Verwendung</strong></p>
   <div class="example-contents">
    <div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Der Wert für die Wiederaufnahme der Fiber: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Der Wert vom Unterbrechen der Fiber: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>Das oben gezeigte Beispiel erzeugt folgende Ausgabe:</p></div>
   <div class="example-contents screen">
    <div class="cdata"><pre>
Der Wert vom Unterbrechen der Fiber: fiber
Der Wert für die Wiederaufnahme der Fiber: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>